signature COMM =
  sig
    type bid = int

    datatype move = MOVE of {robot : int,
                             pos : int * int,
                             picked : World.package list,
                             dropped : World.package list}

    type server

    val contact : string * int -> server

    val init : server -> {board : World.board, me : int}
    val movestart : server -> int -> World.board -> World.board
    val move : server -> int -> bid * action -> World.board -> World.board

    val disconnect : server -> unit
  end
  
