
structure StupidBotIII :> ROBOT =
struct
    open Comm
    open World

    datatype plan = 
	GOTO of int * int

    type mind = plan

    (* find a base to GOTO (except for the one listed) *)
    fun goto_base_not (a,b) (board as BOARD{layout, cap, ...}) (me as ROBOT{loc, ...}) =
	case RobUtil.findspot board (fn (r, c, SPOT{space=Dot true,...}) => (r <> a orelse b <> c) | _ => false) of
	    SOME l => GOTO l
	  | NONE => 
		(case RobUtil.findspot board (fn (r, c, SPOT{space=Dot _,...}) => (r <> a orelse b <> c) | _ => false) of
		   SOME l => GOTO l
                 | NONE => GOTO (1,1)) (* ??? *)
					     

    val init = goto_base_not (~1, ~1)
    val itos = Int.toString
    fun dtos (a,b) = itos a ^ "," ^ itos b
    fun pltos (Ground d) = "@" ^ dtos d
      | pltos (Robot r) = "[rob " ^ itos r ^ "]"

    fun ptos (PACKAGE{id,loc,weight,dest}) = itos id

    fun ktos f (Known n) = f n
      | ktos _ _ = "Unknown"

    fun move (board as BOARD{layout, packages, robots, cap}) dmap (GOTO(a, b)) (me as ROBOT{loc as (r, c), packages=packs, ...}) =
	let in
	    print ("(StupidBot 3.0) I'm at " ^ itos r ^ "," ^ itos c ^ " heading to " ^ itos a ^ "," ^ itos b ^ "\n");
	    print ("Location of known packages:\n     " ^
		   StringUtil.delimit "\n     " (map (fn PACKAGE{id, loc, weight, dest} =>
						      itos id ^ ": " ^ ktos dtos dest ^ " " ^ ktos itos weight ^ "lb. "
						      ^ ktos pltos loc) (World.Map.listItems packages)) ^ "\n");
	if a = r andalso b = c then
	    (* got there! *)
	    (* pick up or put down? *)
	    (case RobUtil.packsdesthere loc packages packs of
		nil => (case packs of
                          nil => (* empty handed!! find a new base? *)
                            (case RobUtil.packsarehere loc packages of
                               nil => 			
                                 let in
                                   print ("Why am I here? Finding a new base...\n");
                                   move board dmap (goto_base_not (a,b) board me) me
                                 end
                             | l => 
                                 let val l = (Knapsack.pickup board layout dmap l (#1 cap))  in
                                   print ("Pick up: " ^ StringUtil.delimit " " (map ptos l) ^ "\n");
			           (GOTO(a,b), 1, Pick l)
                                 end)
                        | (pid::_) =>
				 (case RobUtil.getpackage packages pid of
				      PACKAGE{dest = Known dest, ...} =>
					  let in
					      print ("Now proceeding to " ^ dtos dest ^ " ...\n");
					      move board dmap (GOTO dest) me
					  end
				    | _ => 
					  let in
					      print ("BAD PACKAGE !!! Held by me: " ^ itos pid ^ "\n");
					      raise Fail "oops"
					  end))
	      | l => 
		    let in
			print ("Deliver: " ^ StringUtil.delimit " " (map ptos l) ^ "\n");
			(GOTO(a,b), 1, Drop l)
		    end)
	else
	    let 
		val _ = print ("Find the fastest way to my destination ..\n")
		val move = FloodFill.dirto dmap board (a,b) loc
		val _ = print ("OK! got it! \n")
	    in
		(GOTO(a,b), 1, move)
	    end
	end
end
